Public Class Form1
    Public MyDB As DataSet
    Public IfDB As DataSet
    Public DimDB As DataSet
    Public EditMode As Boolean
    Private masterBindingSource As New BindingSource()
    Private detailsBindingSource As New BindingSource()
    Declare Auto Function FindWindow Lib "USER32.DLL" (ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr

    Function PCDExists() As Boolean
        Dim lpclassname As String
        Dim Result As Integer

        PCDExists = True
        lpclassname = "WilcoxAssociatesIncPC-DMISWndClass"
        Result = FindWindow(lpclassname, vbNullString)
        If Result = 0 Then
            PCDExists = False
        End If
    End Function

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If MsgBox("Si vuole uscire senza salvare le eventauli modifiche?", MsgBoxStyle.YesNo) = MsgBoxResult.No Then
            e.Cancel = True
        End If
        If UCase(My.Settings.Software) = "QUINDOS" Then InterfaceFileWrite("END", "")
    End Sub

    Private Sub Form1Aspect()
        If UCase(My.Settings.Software) = "QUINDOS" Then
            Button5.Text = "Esegui programma in QUINDOS"
            Button5.Visible = False
            Button6.Visible = False
        Else
            Button5.Text = "Apri programma in PC-DMIS"
            Button5.Visible = True
            Button6.Visible = True
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        MyDB = New DataSet
        IfDB = New DataSet
        CreateDBPPs()
        CreateDBInsps()
        CreateDBMeas()
        Me.Text = "PPManager - version " & My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & " - Developed for Secondo Mona, Italy"

        Form1Aspect()

        ToolStrip1.Items(10).Text = "Campo"
        ToolStrip1.Items(12).Text = "Valore"
        Dim comboFieldFilter As Windows.Forms.ToolStripComboBox
        comboFieldFilter = ToolStrip1.Items(11)
        comboFieldFilter.DropDownStyle = ComboBoxStyle.DropDownList
        Dim ifCol As DataColumn
        For Each ifCol In MyDB.Tables(0).Columns
            comboFieldFilter.Items.Add(ifCol.ColumnName)
        Next
        ToolStrip1.Items(0).Enabled = False
        comboFieldFilter.SelectedIndex = 6
        comboFieldFilter.Invalidate()
        My.Settings.Item("Root") = Application.StartupPath
        If My.Settings.Item("DefaultDB") = "" Then My.Settings.Item("DefaultDB") = Application.StartupPath & "\SMDB01"

        ManagePDFConvertMenu()

        LoadDB()
        CheckBox1.CheckState = CheckState.Checked ' Calls LaouInspTable
        CreateDimDB()
    End Sub
    Private Sub CheckBox1_CheckStateChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckStateChanged
        If CheckBox1.CheckState = CheckState.Checked Then LayoutInspTable(1)
        If CheckBox1.CheckState = CheckState.Unchecked Then LayoutInspTable(2)
    End Sub

    Private Sub LayoutInspTable(ByVal Lay As Integer)


        If Lay = 1 Then
            masterBindingSource.DataSource = MyDB
            masterBindingSource.DataMember = "Programs"
            detailsBindingSource.DataSource = masterBindingSource
            detailsBindingSource.DataMember = "Relation1"
            GridPPs.DataSource = masterBindingSource 'MyDB.Tables(0)
            GridInspections.DataSource = detailsBindingSource ' MyDB.Tables(1)

            GridInspections.Columns(1).Visible = False
        End If
        If Lay = 2 Then
            GridPPs.DataSource = MyDB.Tables(0)
            GridInspections.DataSource = MyDB.Tables(1)

            GridInspections.Columns(1).Visible = True
        End If

        GridPPs.ReadOnly = True
        GridPPs.AllowUserToAddRows = False
        GridPPs.Columns(2).Visible = False
        GridPPs.Columns(3).Visible = True
        GridPPs.Columns(1).DefaultCellStyle.BackColor = Color.LightGray
        GridPPs.Columns(3).DefaultCellStyle.BackColor = Color.LightGray

        GridInspections.AllowUserToAddRows = False

    End Sub
    Private Sub CreateDimDB()
        DimDB = New DataSet
        Dim MyTable As DataTable
        MyTable = New Data.DataTable("Dim")
        DimDB.Tables.Add(MyTable)
        Dim idC As New DataColumn("ID", Type.GetType("System.Int32"))
        Dim NOMC As New DataColumn("Nominal", Type.GetType("System.String"))
        Dim UTC As New DataColumn("UT", Type.GetType("System.String"))
        Dim LTC As New DataColumn("LT", Type.GetType("System.String"))
        Dim USLT As New DataColumn("USL", Type.GetType("System.String"))
        Dim LSLT As New DataColumn("LSL", Type.GetType("System.String"))
        idC.Unique = True
        idC.AutoIncrement = True
        MyTable.Columns.Add(idC)
        MyTable.Columns.Add(USLT)
        MyTable.Columns.Add(LSLT)
        MyTable.Columns.Add(NOMC)
        MyTable.Columns.Add(UTC)
        MyTable.Columns.Add(LTC)
        DimDB.AcceptChanges()
    End Sub

    Private Sub CreateDBPPs()
        Dim MyTable As DataTable

        MyTable = New Data.DataTable("Programs")
        MyDB.Tables.Add(MyTable)
        Dim idC As New DataColumn("Program Number", Type.GetType("System.String"))
        Dim PPDescrC As New DataColumn("Description", Type.GetType("System.String"))
        Dim PPImageC As New DataColumn("Image", Type.GetType("System.String"))
        Dim PPFNC As New DataColumn("Comment", Type.GetType("System.String"))
        Dim CustomerC As New DataColumn("Customer", Type.GetType("System.String"))
        Dim ProgramC As New DataColumn("Programme", Type.GetType("System.String"))
        Dim PartC As New DataColumn("Part", Type.GetType("System.String"))
        Dim IssueC As New DataColumn("Issue", Type.GetType("System.String"))
        'Dim PPRevisionC As New DataColumn("PP Revision", Type.GetType("System.String"))
        idC.Unique = True
        'idC.AutoIncrement = True
        MyTable.Columns.Add(idC)
        MyTable.Columns.Add(PPDescrC)
        MyTable.Columns.Add(PPImageC)
        MyTable.Columns.Add(PPFNC)
        MyTable.Columns.Add(CustomerC)
        MyTable.Columns.Add(ProgramC)
        MyTable.Columns.Add(PartC)
        MyTable.Columns.Add(IssueC)
        Dim PKey(1) As DataColumn
        PKey(0) = idC
        MyTable.PrimaryKey = PKey
        'MyTable.Columns.Add(PPRevisionC)
        MyDB.AcceptChanges()

    End Sub
    Private Sub CreateDBInsps()
        Dim MyTable As DataTable

        MyTable = New Data.DataTable("Inspections")
        MyDB.Tables.Add(MyTable)
        Dim idC As New DataColumn("ID", Type.GetType("System.Int32"))
        Dim PidC As New DataColumn("PID", Type.GetType("System.String"))
        Dim TimeDateC As New DataColumn("Date & Time", Type.GetType("System.DateTime"))
        Dim BatchC As New DataColumn("Batch", Type.GetType("System.String"))
        Dim SerialC As New DataColumn("Serial", Type.GetType("System.String"))
        Dim OperatorC As New DataColumn("Operator", Type.GetType("System.String"))
        'Dim CMMSNC As New DataColumn("CMM S/N", Type.GetType("System.String"))
        Dim NoteC As New DataColumn("Note", Type.GetType("System.String"))
        idC.Unique = True
        idC.AutoIncrement = True
        MyTable.Columns.Add(idC)
        MyTable.Columns.Add(PidC)
        MyTable.Columns.Add(TimeDateC)
        MyTable.Columns.Add(BatchC)
        MyTable.Columns.Add(SerialC)
        MyTable.Columns.Add(OperatorC)
        'MyTable.Columns.Add(CMMSNC)
        MyTable.Columns.Add(NoteC)
        Dim PKey(1) As DataColumn
        PKey(0) = idC
        MyTable.PrimaryKey = PKey
        MyDB.Relations.Add("Relation1", MyDB.Tables(0).Columns(0), PidC)
        MyDB.AcceptChanges()
    End Sub

    Private Sub CreateDBMeas()
        Dim MyTable As DataTable

        MyTable = New Data.DataTable("Measurements")
        MyDB.Tables.Add(MyTable)
        Dim idC As New DataColumn("ID", Type.GetType("System.Int32"))
        Dim iidC As New DataColumn("IID", Type.GetType("System.Int32"))
        Dim CommentC As New DataColumn("Comment", Type.GetType("System.String"))
        Dim FeatNameC As New DataColumn("FeatName", Type.GetType("System.String"))
        Dim FeatTypeC As New DataColumn("FeatType", Type.GetType("System.String"))
        Dim NOMC As New DataColumn("Nominal", Type.GetType("System.Double"))
        Dim UTC As New DataColumn("UT", Type.GetType("System.Double"))
        Dim LTC As New DataColumn("LT", Type.GetType("System.Double"))
        Dim MEAC As New DataColumn("Measured", Type.GetType("System.Double"))
        idC.Unique = True
        idC.AutoIncrement = True
        MyTable.Columns.Add(idC)
        MyTable.Columns.Add(iidC)
        MyTable.Columns.Add(FeatNameC)
        MyTable.Columns.Add(FeatTypeC)
        MyTable.Columns.Add(NOMC)
        MyTable.Columns.Add(UTC)
        MyTable.Columns.Add(LTC)
        MyTable.Columns.Add(MEAC)
        MyTable.Columns.Add(CommentC)
        Dim PKey(1) As DataColumn
        PKey(0) = idC
        MyTable.PrimaryKey = PKey
        MyDB.Relations.Add("Relation2", MyDB.Tables(1).Columns(0), iidC)
        MyDB.AcceptChanges()
    End Sub


    Private Sub SaveDB(Optional ByVal fn As String = "")
        If fn = "" Then fn = My.Settings.Item("DefaultDB")
        Dim fstr As New System.IO.FileStream(fn & ".xml", System.IO.FileMode.Create)
        MyDB.WriteXml(fstr)
        fstr.Close()
        Dim fstr1 As New System.IO.FileStream(fn & ".xsd", System.IO.FileMode.Create)
        MyDB.WriteXmlSchema(fstr1)
        fstr1.Close()
    End Sub

    Private Sub LoadDB(Optional ByVal fn As String = "")
        If fn = "" Then fn = My.Settings.Item("DefaultDB")

        If My.Computer.FileSystem.FileExists(fn & ".xml") = False Then
            MsgBox("File " & fn & ".xml" & " not found!", MsgBoxStyle.Information)
            Exit Sub
        End If
        If My.Computer.FileSystem.FileExists(fn & ".xsd") = False Then
            MsgBox("File " & fn & ".xsd" & " not found!")
            Exit Sub
        End If

        MyDB.Clear()
        MyDB.Relations.Clear()
        MyDB = Nothing
        MyDB = New DataSet

        Dim fstr1 As New System.IO.FileStream(fn & ".xsd", System.IO.FileMode.Open)
        MyDB.ReadXmlSchema(fstr1)
        fstr1.Close()
        Dim fstr As New System.IO.FileStream(fn & ".xml", System.IO.FileMode.Open)
        MyDB.ReadXml(fstr)
        fstr.Close()

    End Sub


    Private Sub Filtering(ByVal Field As String, ByVal Cri As String)
        ' Filtering

        Dim DRow As DataRow
        Dim i As Integer
        i = 0
        For Each DRow In MyDB.Tables(0).Rows
            GridPPs.Rows(i).Visible = True
            i = i + 1
        Next
        If Cri = "" Then Exit Sub
        i = 0
        For Each DRow In MyDB.Tables(0).Rows
            If DRow.Item(Field).ToString Like Cri Then
                GridPPs.Rows(i).Visible = True
            Else
                If i <> GridPPs.CurrentRow.Index Then
                    GridPPs.Rows(i).Visible = False
                End If
            End If
            i = i + 1
        Next
    End Sub


    Private Sub SettingsToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SettingsToolStripMenuItem1.Click
        Dialog3.ShowDialog()
        Form1Aspect()
    End Sub




    Private Sub ToolStripButton8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton8.Click
        Dim comboFieldFilter As Windows.Forms.ToolStripComboBox
        comboFieldFilter = ToolStrip1.Items(11)
        Dim comboValueFilter As Windows.Forms.ToolStripComboBox
        comboValueFilter = ToolStrip1.Items(13)
        Filtering(comboFieldFilter.Text, comboValueFilter.Text)
    End Sub


    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim PathPP As String
        PathPP = My.Settings.Root & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(4) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(5) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(6) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(7)
        PathPP = PathPP & "\P_" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(0) & "_" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(1)

        If My.Settings.Software = "QUINDOS" Then
            InterfaceFileWrite("RUN", PathPP)
        Else
            Dim PCDApp As PCDLRN.Application
            Dim PP As PCDLRN.PartProgram
            Dim PPs As PCDLRN.PartPrograms

            If My.Computer.FileSystem.FileExists(PathPP & ".prg") = False Then
                MsgBox("Programma " & PathPP & " non trovato!", MsgBoxStyle.Critical)
                Exit Sub
            End If
            If PCDExists() = False Then
                MsgBox("PC-DMIS non  aperto!" & vbCrLf & vbCrLf & "Aprire PC-DMIS manualmente e riprovare!", MsgBoxStyle.Information)
                Exit Sub
            End If
            My.Computer.FileSystem.CopyFile(PathPP & ".prg", My.Settings.Root & "\pippo.prg", True)
            Try
                My.Computer.FileSystem.CopyFile(PathPP & ".cad", My.Settings.Root & "\pippo.cad", True)
            Catch ex As Exception

            End Try

            PCDApp = CreateObject("PCDLRN.Application")
            PPs = PCDApp.PartPrograms
            If PPs.Count > 0 Then
                If MsgBox("Alcuni programmi in PC-DMIS risultano aperti. Chiudere i programmi?", MsgBoxStyle.YesNo) = MsgBoxResult.No Then Exit Sub
                PPs.CloseAll()
            End If
            PP = PPs.Open(My.Settings.Root & "\pippo.prg", "CMM1")
            'If MsgBox("Programma carricato! Si vuole eseguire il programma?", MsgBoxStyle.YesNo) = MsgBoxResult.No Then Exit Sub
            'PP.EXECUTE()
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim ifCol As DataColumn 'System.Windows.Forms.DataGridViewColumn
        Dim ifRow As DataRow
        Dim NewRow As DataRow
        Dim i As Integer

        IfDB.Clear()
        IfDB = Nothing
        IfDB = New DataSet


        Dim MyTable As DataTable
        MyTable = New Data.DataTable("Inputs")
        IfDB.Tables.Add(MyTable)
        Dim C1 As New DataColumn("Item", Type.GetType("System.String"))
        Dim C2 As New DataColumn("Value", Type.GetType("System.String"))
        MyTable.Columns.Add(C1)
        MyTable.Columns.Add(C2)
        i = 0
        For Each ifCol In MyDB.Tables(0).Columns
            NewRow = IfDB.Tables(0).NewRow()
            NewRow(0) = ifCol.ColumnName
            Try
                NewRow(1) = MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(i)
                i = i + 1
            Catch ex As Exception
            End Try
            IfDB.Tables(0).Rows.Add(NewRow)
        Next


        IfDB.AcceptChanges()
        EditMode = False
        Dialog1.ShowDialog()
        If Dialog1.DialogResult = Windows.Forms.DialogResult.Cancel Then Exit Sub


        Dim PathPP As String
        Dim OldName As String
        PathPP = My.Settings.Root & "\" & IfDB.Tables(0).Rows(4).Item(1) & "\" & IfDB.Tables(0).Rows(5).Item(1) & "\" & IfDB.Tables(0).Rows(6).Item(1) & "\" & IfDB.Tables(0).Rows(7).Item(1)
        NewRow = MyDB.Tables(0).NewRow
        i = 0
        For Each ifRow In IfDB.Tables(0).Rows
            If i = 2 Then
                If ifRow.Item(1).Equals(System.DBNull.Value) Then ifRow.Item(1) = " "
                If My.Computer.FileSystem.FileExists(ifRow.Item(1)) Then
                    If ifRow.Item(1).ToString <> PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString) Then
                        My.Computer.FileSystem.CopyFile(ifRow.Item(1).ToString, PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString), True)
                        ifRow.Item(1) = PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString)
                    End If
                End If
            End If
            NewRow(i) = ifRow.Item(1)
            i = i + 1
        Next
        MyDB.Tables(0).Rows.Add(NewRow)
        If My.Computer.FileSystem.FileExists(PathPP & "\P_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(0) & "_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(1)) Then
            MsgBox("Il programma " & PathPP & "\P_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(0) & "_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(1) & "esiste gi!", MsgBoxStyle.Exclamation)
            MyDB.RejectChanges()
            Exit Sub
        End If
        MyDB.AcceptChanges()

        My.Computer.FileSystem.CreateDirectory(PathPP)

        If UCase(My.Settings.Software) = "QUINDOS" Then
            InterfaceFileWrite("SAVE", PathPP & "\P_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(0) & "_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(1))
        Else
            Dim PCDApp As PCDLRN.Application
            Dim PP As PCDLRN.PartProgram
            If PCDExists() = False Then
                MsgBox("PC-DMIS non  aperto!" & vbCrLf & vbCrLf & "La voce  stata creata, ma il programma non  assegnato!", MsgBoxStyle.Information)
                Exit Sub
            End If
            PCDApp = CreateObject("PCDLRN.Application")
            PP = PCDApp.ActivePartProgram
            If PP Is Nothing Then
                MsgBox("Nessun programma aperto in PC-DMIS!" & vbCrLf & vbCrLf & "La voce  stata creata, ma il programma non  assegnato!", MsgBoxStyle.Information)
                Exit Sub
            End If
            OldName = PP.FullName
            Me.Refresh()
            Dialog5.Show()
            Dialog5.Refresh()
            PP.SaveAs(PathPP & "\P_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(0) & "_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(1))
            PP.SaveAs(OldName)
        End If
        Dialog5.Close()

    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click


        Dim ifCol As DataColumn 'System.Windows.Forms.DataGridViewColumn
        Dim ifRow As DataRow
        Dim NewRow As DataRow
        Dim i As Integer

        IfDB.Clear()
        IfDB = Nothing
        IfDB = New DataSet


        Dim MyTable As DataTable
        MyTable = New Data.DataTable("Inputs")
        IfDB.Tables.Add(MyTable)
        Dim C1 As New DataColumn("Item", Type.GetType("System.String"))
        Dim C2 As New DataColumn("Value", Type.GetType("System.String"))
        MyTable.Columns.Add(C1)
        MyTable.Columns.Add(C2)
        i = 0
        For Each ifCol In MyDB.Tables(0).Columns
            NewRow = IfDB.Tables(0).NewRow()
            NewRow(0) = ifCol.ColumnName
            Try
                NewRow(1) = MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(i)
                i = i + 1
            Catch ex As Exception
            End Try
            IfDB.Tables(0).Rows.Add(NewRow)
        Next


        IfDB.AcceptChanges()
        EditMode = True
        Dialog1.ShowDialog()
        If Dialog1.DialogResult = Windows.Forms.DialogResult.Cancel Then Exit Sub

        Dim OldPathPP As String
        Dim PathPP As String
        OldPathPP = My.Settings.Root & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(4) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(5) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(6) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(7)
        PathPP = My.Settings.Root & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(4) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(5) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(6) & "\" & IfDB.Tables(0).Rows(7).Item(1).ToString
        If OldPathPP <> PathPP Then
            Try
                My.Computer.FileSystem.RenameDirectory(OldPathPP, IfDB.Tables(0).Rows(7).Item(1).ToString)
            Catch ex As Exception

            End Try
        End If

        Dim OldDescr As String
        Dim Descr As String
        Try
            OldDescr = MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(1)
        Catch ex As Exception
            OldDescr = ""
        End Try
        Descr = IfDB.Tables(0).Rows(1).Item(1).ToString
        If OldDescr <> Descr Then
            Try
                If UCase(My.Settings.Software) = "QUINDOS" Then
                    My.Computer.FileSystem.RenameFile(PathPP & "\P_" & IfDB.Tables(0).Rows(0).Item(1).ToString & "_" & OldDescr & ".wdb", "P_" & IfDB.Tables(0).Rows(0).Item(1).ToString & "_" & Descr & ".wdb")
                Else
                    My.Computer.FileSystem.RenameFile(PathPP & "\P_" & IfDB.Tables(0).Rows(0).Item(1).ToString & "_" & OldDescr & ".prg", "P_" & IfDB.Tables(0).Rows(0).Item(1).ToString & "_" & Descr & ".prg")
                    My.Computer.FileSystem.RenameFile(PathPP & "\P_" & IfDB.Tables(0).Rows(0).Item(1).ToString & "_" & OldDescr & ".cad", "P_" & IfDB.Tables(0).Rows(0).Item(1).ToString & "_" & Descr & ".cad")
                End If
            Catch ex As Exception

            End Try
        End If



        i = 0
        For Each ifRow In IfDB.Tables(0).Rows
            If i = 2 Then
                If ifRow.Item(1).Equals(System.DBNull.Value) Then ifRow.Item(1) = " "
                If My.Computer.FileSystem.FileExists(ifRow.Item(1)) Then
                    If ifRow.Item(1).ToString <> PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString) Then
                        My.Computer.FileSystem.CopyFile(ifRow.Item(1).ToString, PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString), True)
                        ifRow.Item(1) = PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString)
                    End If
                End If
            End If
            MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(i) = ifRow.Item(1)
            i = i + 1
        Next
        MyDB.AcceptChanges()
        If PathPP <> OldPathPP Then
            MsgBox("E' stata aggiornata la ""issue""! DataBase viene salvato per sicurezza!", MsgBoxStyle.Information)
            SaveDB()
        End If
    End Sub

    Private Sub Button4_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim ifCol As DataColumn 'System.Windows.Forms.DataGridViewColumn
        Dim NewRow As DataRow
        Dim ifRow As DataRow
        Dim i As Integer


        If UCase(My.Settings.Software) = "QUINDOS" Then

            If My.Computer.FileSystem.FileExists("c:\amsu\flexreport\flexreport.exe") = False Then
                MsgBox("FlexReport non risulta installato! (installare su c:\amsu\flexreport)", MsgBoxStyle.Critical)
                Exit Sub
            End If
            If My.Computer.FileSystem.FileExists("c:\amsu\flexreport\flexreport.txt") = False Then
                MsgBox("Nessun rapporto trovato! (file c:\amsu\flexreport\flexreport.txt)", MsgBoxStyle.Critical)
                Exit Sub
            End If

            Shell("c:\amsu\flexreport\flexreport.exe", AppWinStyle.MaximizedFocus, True)
        End If

        IfDB.Clear()
        IfDB = Nothing
        IfDB = New DataSet

        Dim MyTable As DataTable
        MyTable = New Data.DataTable("Inputs")
        IfDB.Tables.Add(MyTable)
        Dim C1 As New DataColumn("Item", Type.GetType("System.String"))
        Dim C2 As New DataColumn("Value", Type.GetType("System.String"))
        MyTable.Columns.Add(C1)
        MyTable.Columns.Add(C2)
        For Each ifCol In MyDB.Tables(0).Columns
            NewRow = IfDB.Tables(0).NewRow()
            NewRow(0) = ifCol.ColumnName
            NewRow(1) = MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(i)
            IfDB.Tables(0).Rows.Add(NewRow)
            i = i + 1
        Next
        IfDB.AcceptChanges()


        MyTable = New Data.DataTable("Inputs1")
        IfDB.Tables.Add(MyTable)
        Dim C3 As New DataColumn("Item", Type.GetType("System.String"))
        Dim C4 As New DataColumn("Value", Type.GetType("System.String"))
        MyTable.Columns.Add(C3)
        MyTable.Columns.Add(C4)
        i = 0
        For Each ifCol In MyDB.Tables(1).Columns
            NewRow = IfDB.Tables(1).NewRow()
            NewRow(0) = ifCol.ColumnName
            IfDB.Tables(1).Rows.Add(NewRow)
            i = i + 1
        Next
        'IfDB.Tables(1).Rows(0).Item(1) = MyDB.Tables(1).Rows.Count
        IfDB.Tables(1).Rows(1).Item(1) = MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(0)
        IfDB.Tables(1).Rows(2).Item(1) = Now
        IfDB.AcceptChanges()

        Dialog2.ShowDialog()
        If Dialog2.DialogResult = Windows.Forms.DialogResult.Cancel Then Exit Sub


        NewRow = MyDB.Tables(1).NewRow
        i = 0
        For Each ifRow In IfDB.Tables(1).Rows
            If i > 0 Then NewRow(i) = ifRow.Item(1)
            i = i + 1
        Next
        MyDB.Tables(1).Rows.Add(NewRow)

        Dim FeatName As String = "", RefName As String = ""
        Dim FeatAxis As String = ""
        Dim SingleLineDim As Boolean
        Dim UT As Double, LT As Double, MEA As Double, NOM As Double
        Dim Comment As String = ""
        Dim j As Integer
        Dim PrevWasComment As Boolean

        If UCase(My.Settings.Software) = "QUINDOS" Then


            Dim MyFile As Microsoft.VisualBasic.FileIO.TextFieldParser
            MyFile = My.Computer.FileSystem.OpenTextFieldParser("c:\amsu\flexreport\flexreport.txt")
            MyFile.Delimiters = New String() {","}

            Dim currentRow As String()
            While Not MyFile.EndOfData
                Try
                    currentRow = MyFile.ReadFields()
                    If Mid(currentRow(0), 1, 4) <> "$END" Then
                        If Mid(currentRow(0), 1, 1) = "$" Then
                            If PrevWasComment = False Then
                                Comment = Replace(currentRow(0), "$", "")
                            Else
                                Comment = Comment & vbCrLf & Replace(currentRow(0), "$", "")
                            End If
                            PrevWasComment = True
                        End If
                    End If
                    Dim currentField As String
                    If currentRow.GetUpperBound(0) > 0 Then
                        PrevWasComment = False
                        j = 0
                        For Each currentField In currentRow
                            j = j + 1
                            If j = 2 Then FeatName = currentField
                            If j = 3 Then FeatName = FeatName & "(" & currentField & ")"
                            If j = 4 Then FeatAxis = currentField
                            Try
                                If j = 5 Then NOM = CDbl(currentField)
                                If j = 6 Then UT = CDbl(currentField)
                                If j = 7 Then LT = CDbl(currentField)
                                If j = 8 Then MEA = CDbl(currentField)
                            Catch ex As Exception
                                Try
                                    If j = 5 Then NOM = RecDMS(currentField)
                                    If j = 6 Then UT = RecDMS(currentField)
                                    If j = 7 Then LT = RecDMS(currentField)
                                    If j = 8 Then MEA = RecDMS(currentField)
                                Catch ex1 As Exception

                                End Try
                            End Try
                        Next
                        NewRow = MyDB.Tables(2).NewRow
                        NewRow(1) = MyDB.Tables(1).Rows(MyDB.Tables(1).Rows.Count - 1).Item(0)
                        NewRow(2) = FeatName : NewRow(3) = FeatAxis : NewRow(4) = NOM : NewRow(5) = UT : NewRow(6) = LT : NewRow(7) = MEA : NewRow(8) = Comment
                        NewRow(8) = Comment
                        MyDB.Tables(2).Rows.Add(NewRow)
                    End If
                Catch ex As Microsoft.VisualBasic.FileIO.MalformedLineException
                End Try
            End While

            MyFile.Close()


        Else
            ' PC-DMIS starts here
            Dim PCDApp As PCDLRN.Application
            Dim PP As PCDLRN.PartProgram
            Dim Cmds As PCDLRN.Commands
            Dim Cmd As PCDLRN.Command
            Dim DCmd As PCDLRN.DimensionCmd

            If PCDExists() = False Then
                MsgBox("PC-DMIS non  aperto!" & vbCrLf & vbCrLf & "Non  possibile creare l'ispezione!", MsgBoxStyle.Information)
                MyDB.RejectChanges()
                Exit Sub
            End If
            Comment = ""
            PCDApp = CreateObject("PCDLRN.Application")
            PP = PCDApp.ActivePartProgram
            If PP Is Nothing Then
                MsgBox("Nessun programma aperto in PC-DMIS!" & vbCrLf & vbCrLf & "L'ispezione non  stata creata!")
                MyDB.RejectChanges()
                Exit Sub
            End If



            Me.Refresh()
            Dialog5.Show()
            Dialog5.Refresh()
            Dialog5.ProgressBar1.Maximum = PP.Commands.Count
            Dialog5.ProgressBar1.Minimum = 0

            Cmds = PP.Commands
            For i = 1 To Cmds.Count
                Dialog5.ProgressBar1.Value = i
                Cmd = Cmds.Item(i)
                If Cmd.Type = PCDLRN.OBTYPE.SET_COMMENT Then
                    If Cmd.GetText(190, 1).Substring(0, 1) = "R" Then
                        For j = 1 To 100
                            If Cmd.GetText(PCDLRN.ENUM_FIELD_TYPES.COMMENT_FIELD, j).Length = 0 Then Exit For
                            If PrevWasComment Then
                                Comment = Comment & vbCrLf & (Cmd.GetText(PCDLRN.ENUM_FIELD_TYPES.COMMENT_FIELD, j))
                            Else
                                Comment = (Cmd.GetText(PCDLRN.ENUM_FIELD_TYPES.COMMENT_FIELD, j))
                            End If
                            PrevWasComment = True
                        Next j
                    End If
                End If

                If Cmd.IsDimension Then
                    PrevWasComment = False
                    DCmd = Cmd.DimensionCommand

                    If My.Settings.UnitsAreInch = True Then
                        DCmd.Units = PCDLRN.UNITTYPE.INCH
                    Else
                        DCmd.Units = PCDLRN.UNITTYPE.MM
                    End If
                    'Cmd.ReDraw()


                    If Len(DCmd.ID) <> 0 Then
                        FeatName = DCmd.ID
                        RefName = ""
                        If DCmd.Feat1 <> "" Then RefName = " (" & DCmd.Feat1
                        If DCmd.Feat2 <> "" Then RefName = RefName & " - " & DCmd.Feat2
                        If DCmd.Feat3 <> "" Then RefName = RefName & " - " & DCmd.Feat3
                        If RefName <> "" Then RefName = RefName & ")"
                        FeatName = FeatName & RefName
                        SingleLineDim = True
                        If DCmd.IsLocationAxis Then SingleLineDim = False
                        If DCmd.IsTruePosAxis Then SingleLineDim = False

                        If SingleLineDim = False And DCmd.AxisLetter = "" Then
                        Else
                            UT = DCmd.Plus
                            LT = DCmd.Minus
                            LT = LT * (-1)
                            NOM = DCmd.NOMINAL
                            MEA = DCmd.Measured
                            FeatAxis = Cmd.Type
                            If FeatAxis = "1118" Or FeatAxis = "1105" Then
                                If DCmd.Profile = PCDLRN.ENUM_DIM_PROF_TYPE.DIM_PROF_FORM_AND_LOCATION Then
                                    FeatName = FeatName & " - Form and location"
                                    Dim myMin, myMax As Double
                                    myMin = DCmd.Min : myMax = DCmd.Max
                                    NOM = (UT + LT) * 0.5
                                    UT = UT - LT
                                    LT = 0
                                    myMin = myMin - NOM
                                    myMax = myMax - NOM
                                    If Math.Abs(myMax) > Math.Abs(myMin) Then MEA = 2 * Math.Abs(myMax)
                                    If Math.Abs(myMax) <= Math.Abs(myMin) Then MEA = 2 * Math.Abs(myMin)
                                End If
                                If DCmd.Profile = PCDLRN.ENUM_DIM_PROF_TYPE.DIM_PROF_FORM_ONLY Then
                                    FeatName = FeatName & " - Form only"
                                End If
                            End If
                            NewRow = MyDB.Tables(2).NewRow
                            NewRow(1) = MyDB.Tables(1).Rows(MyDB.Tables(1).Rows.Count - 1).Item(0)
                            NewRow(2) = FeatName : NewRow(3) = FeatAxis : NewRow(4) = NOM : NewRow(5) = UT : NewRow(6) = LT : NewRow(7) = MEA : NewRow(8) = Comment
                            If FeatAxis = "1000" Or FeatAxis = "1200" Then
                            Else
                                MyDB.Tables(2).Rows.Add(NewRow)
                            End If
                        End If
                    Else
                        ' This is For Multiple Line Dimension commands
                        UT = DCmd.Plus
                        LT = DCmd.Minus
                        LT = LT * (-1)
                        NOM = DCmd.NOMINAL
                        MEA = DCmd.Measured
                        FeatAxis = DCmd.AxisLetter
                        If FeatAxis = "TP" Then
                            MEA = DCmd.Deviation
                            UT = UT + DCmd.Bonus
                        End If
                        NewRow = MyDB.Tables(2).NewRow
                        NewRow(1) = MyDB.Tables(1).Rows(MyDB.Tables(1).Rows.Count - 1).Item(0)
                        NewRow(2) = FeatName : NewRow(3) = FeatAxis : NewRow(4) = NOM : NewRow(5) = UT : NewRow(6) = LT : NewRow(7) = MEA : NewRow(8) = Comment
                        MyDB.Tables(2).Rows.Add(NewRow)
                    End If
                End If
            Next
        End If

        MyDB.AcceptChanges()
        Dialog5.Close()

    End Sub

    Private Sub Button8_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        CompileIfDB()
        Dialog4.ShowDialog()
    End Sub

    Private Sub CompileIfDB()
        Dim ifCol As DataColumn 'System.Windows.Forms.DataGridViewColumn
        Dim NewRow As DataRow
        Dim i As Integer


        IfDB.Clear()
        IfDB = Nothing
        IfDB = New DataSet

        Dim MyTable As DataTable
        MyTable = New Data.DataTable("Inputs")
        IfDB.Tables.Add(MyTable)
        Dim C1 As New DataColumn("Item", Type.GetType("System.String"))
        Dim C2 As New DataColumn("Value", Type.GetType("System.String"))
        MyTable.Columns.Add(C1)
        MyTable.Columns.Add(C2)
        Dim RelN As String
        RelN = GridInspections.CurrentRow.Cells.Item(1).Value
        For Each ifCol In MyDB.Tables(0).Columns
            NewRow = IfDB.Tables(0).NewRow()
            NewRow(0) = ifCol.ColumnName
            NewRow(1) = MyDB.Tables(0).Rows.Find(RelN).Item(i) 'MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(i)
            IfDB.Tables(0).Rows.Add(NewRow)
            i = i + 1
        Next
        IfDB.AcceptChanges()


        MyTable = New Data.DataTable("Inputs1")
        IfDB.Tables.Add(MyTable)
        Dim C3 As New DataColumn("Item", Type.GetType("System.String"))
        Dim C4 As New DataColumn("Value", Type.GetType("System.String"))
        MyTable.Columns.Add(C3)
        MyTable.Columns.Add(C4)
        i = 0
        For Each ifCol In MyDB.Tables(1).Columns
            NewRow = IfDB.Tables(1).NewRow()
            NewRow(0) = ifCol.ColumnName
            NewRow(1) = MyDB.Tables(1).Rows.Find(GridInspections.CurrentRow.Cells.Item(0).Value).Item(i)
            IfDB.Tables(1).Rows.Add(NewRow)
            i = i + 1
        Next
        IfDB.AcceptChanges()

    End Sub

    Private Sub LoadPPInPDDMISToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadPPInPDDMISToolStripMenuItem.Click
        Button3_Click("", Nothing)
    End Sub

    Private Sub ExecutePPInPCDMISToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExecutePPInPCDMISToolStripMenuItem.Click
        Button7_Click("", Nothing)
    End Sub

    Private Sub RegisterNewPPToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RegisterNewPPToolStripMenuItem.Click
        Button5_Click("", Nothing)
    End Sub

    Private Sub CreateNewInspectionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreateNewInspectionToolStripMenuItem.Click
        Button4_Click_1("", Nothing)
    End Sub

    Private Sub ViewInspectionReportToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ViewInspectionReportToolStripMenuItem.Click
        Button8_Click_1("", Nothing)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        SaveDB()
        If UCase(My.Settings.Software) = "QUINDOS" Then InterfaceFileWrite("END", "")
        End
    End Sub

    Private Sub SalvaEdEsciToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SalvaEdEsciToolStripMenuItem.Click
        Button1_Click("", Nothing)
    End Sub

    Private Sub EsciSenzaSalvareToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EsciSenzaSalvareToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub LoadDBToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadDBToolStripMenuItem.Click
        LoadDB()
        LayoutInspTable(1)
        CheckBox1.CheckState = CheckState.Checked ' Calls LaouInspTable
    End Sub

    Private Sub SaveDBToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveDBToolStripMenuItem.Click
        SaveDB()
    End Sub

    Private Sub ToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem1.Click
        MyDB.Clear()
        MyDB.Relations.Clear()
        MyDB = Nothing
        MyDB = New DataSet
        CreateDBPPs()
        CreateDBInsps()
        CreateDBMeas()
        masterBindingSource.DataSource = MyDB
        masterBindingSource.DataMember = "Programs"
        detailsBindingSource.DataSource = masterBindingSource
        detailsBindingSource.DataMember = "Relation1"
        GridPPs.DataSource = masterBindingSource 'MyDB.Tables(0)
        GridInspections.DataSource = detailsBindingSource ' MyDB.Tables(1)
    End Sub

    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
        ToolStripMenuItem1_Click("", Nothing)
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        OpenFileDialog1.DefaultExt = ".xml"
        OpenFileDialog1.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.*"
        OpenFileDialog1.FilterIndex = 1
        OpenFileDialog1.RestoreDirectory = True
        OpenFileDialog1.FileName = ""
        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            LoadDB(OpenFileDialog1.FileName.Remove(Len(OpenFileDialog1.FileName) - 4, 4))
            LayoutInspTable(1)
            CheckBox1.CheckState = CheckState.Checked ' Calls LaouInspTable
        End If
    End Sub

    Private Sub SalvaDBInFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SalvaDBInFileToolStripMenuItem.Click
        SaveFileDialog1.DefaultExt = ".xml"
        If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            SaveDB(SaveFileDialog1.FileName.Remove(Len(SaveFileDialog1.FileName) - 4, 4))
        End If
    End Sub

    Private Sub ToolStripButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton2.Click
        LoadDB()
        LayoutInspTable(1)
        CheckBox1.CheckState = CheckState.Checked ' Calls LaouInspTable
    End Sub

    Private Sub ToolStripButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton3.Click
        SaveDB()
        MsgBox("Salvataggio effettuato con successo!", MsgBoxStyle.Information)
    End Sub



    Private Sub InterfaceFileWrite(ByVal Str1 As String, ByVal Str2 As String)
        Dim InterfaceFile As System.IO.StreamWriter
        InterfaceFile = My.Computer.FileSystem.OpenTextFileWriter("c:\amsu\PPManager\interface.txt", False)
        InterfaceFile.WriteLine(Str1)
        InterfaceFile.WriteLine(Str2)
        InterfaceFile.Close()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If UCase(My.Settings.Software) = "QUINDOS" Then InterfaceFileWrite("END", "")
        Me.Close()
    End Sub

    Private Sub GridPPs_Invalidated(ByVal sender As Object, ByVal e As System.Windows.Forms.InvalidateEventArgs) Handles GridPPs.Invalidated
        If GridPPs.Rows.Count = 0 Then Button5.Enabled = False Else Button5.Enabled = True
        If GridPPs.Rows.Count = 0 Then Button7.Enabled = False Else Button7.Enabled = True
        If GridPPs.Rows.Count = 0 Then Button4.Enabled = False Else Button4.Enabled = True
    End Sub

    Private Sub GridInspections_Invalidated(ByVal sender As Object, ByVal e As System.Windows.Forms.InvalidateEventArgs) Handles GridInspections.Invalidated
        If GridInspections.Rows.Count = 0 Then Button8.Enabled = False Else Button8.Enabled = True

    End Sub

    Private Sub ToolStripComboBox2_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles ToolStripComboBox2.KeyDown
        If e.KeyCode = 13 Then
            ToolStripButton8_Click("", Nothing)
        End If

    End Sub




    Private Sub ToolStripButton4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton4.Click
        Button5_Click("", Nothing)
    End Sub

    Private Sub ToolStripButton5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton5.Click
        Button3_Click("", Nothing)
    End Sub

    Private Sub ToolStripButton6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton6.Click
        Button7_Click("", Nothing)
    End Sub

    Private Sub ToolStripButton7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton7.Click
        Button4_Click_1("", Nothing)
    End Sub



    Private Sub GridPPs_UserDeletingRow(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowCancelEventArgs) Handles GridPPs.UserDeletingRow
        If MsgBox("Si vuole eliminare il programma " & e.Row.Cells.Item(0).Value & " ? Insieme al programma si eliminano anche tutte le ispezioni.", MsgBoxStyle.YesNo) = MsgBoxResult.No Then
            e.Cancel = True
        End If
    End Sub


    Private Sub GridInspections_UserDeletingRow(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewRowCancelEventArgs) Handles GridInspections.UserDeletingRow
        If MsgBox("Si vuole eliminare l'ispezione ID:" & e.Row.Cells.Item(0).Value & " ?", MsgBoxStyle.YesNo) = MsgBoxResult.No Then
            e.Cancel = True
        End If
    End Sub

    Private Sub CalcolatoreTolleranzeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CalcolatoreTolleranzeToolStripMenuItem.Click
        Dialog6.ShowDialog()
    End Sub

    Private Sub CambiaUnitDimInPCDMISToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CambiaUnitDimInPCDMISToolStripMenuItem.Click
        Dim Result As DialogResult
        Result = MsgBox("Cambiare unit nel programma corrente in MM? (SI - MM, NO - Polici)", MsgBoxStyle.YesNoCancel)
        If Result = MsgBoxResult.Cancel Then Exit Sub

        Dim PCDApp As Object
        Dim PP As PCDLRN.PartProgram
        Dim Cmds As PCDLRN.Commands
        Dim Cmd As PCDLRN.Command
        Dim DCmd As PCDLRN.DimensionCmd
        Dim i As Integer, j As Integer

        If PCDExists() = False Then
            MsgBox("PC-DMIS non  aperto!", MsgBoxStyle.Information)
            Exit Sub
        End If
        PCDApp = CreateObject("PCDLRN.Application")
        PP = PCDApp.ActivePartProgram
        If PP Is Nothing Then
            MsgBox("Nessun programma aperto in PC-DMIS!")
            Exit Sub
        End If

        Me.Refresh()
        Dialog5.Show()
        Dialog5.Refresh()
        Dialog5.ProgressBar1.Maximum = PP.Commands.Count
        Dialog5.ProgressBar1.Minimum = 0

        Cmds = PP.Commands
        j = 0
        For i = 1 To Cmds.Count
            Dialog5.ProgressBar1.Value = i
            Cmd = Cmds.Item(i)
            If Cmd.IsDimension Then
                DCmd = Cmd.DimensionCommand
                j = j + 1
                If Result = Windows.Forms.DialogResult.No Then
                    DCmd.Units = PCDLRN.UNITTYPE.INCH
                Else
                    DCmd.Units = PCDLRN.UNITTYPE.MM
                End If
                Cmd.ReDraw()

            End If
        Next
        Dialog5.Close()

        MsgBox("Trovati e aggiustati " & j & " dimensioni", MsgBoxStyle.Information)
    End Sub

    Private Sub UnisciPDFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UnisciPDFToolStripMenuItem.Click
        Dim file, files() As String
        Dim Arg1 As String = ""
        Dim ExeLine As String
        Dim outFile As String
        Dim sDevice, sExtension As String, iIndex As Integer
        sDevice = "pdfwrite"
        sExtension = ".pdf"
        iIndex = 1
        If My.Settings.ArchiveFileType.ToUpper = "PNG" Then sDevice = "png256" : sExtension = ".png" : iIndex = 2
        If My.Settings.ArchiveFileType.ToUpper = "JPG" Or My.Settings.ArchiveFileType.ToUpper = "JPEG" Then sDevice = "jpeg" : sExtension = ".jpg" : iIndex = 3
        If My.Settings.ArchiveFileType.ToUpper = "BMP" Then sDevice = "bmp16" : sExtension = ".bmp" : iIndex = 4
        If My.Settings.ArchiveFileType.ToUpper = "TIFF" Or My.Settings.ArchiveFileType.ToUpper = "TIF" Then sDevice = "tiffcrle" : sExtension = ".tif" : iIndex = 5


        CompileIfDB()

        Dim outFilePath As String
        outFilePath = My.Settings.Root & "\Reports\" & IfDB.Tables(0).Rows(4).Item(1) & "\" & IfDB.Tables(0).Rows(5).Item(1) & "\" & IfDB.Tables(0).Rows(6).Item(1) & "\" & IfDB.Tables(0).Rows(7).Item(1)
        If My.Computer.FileSystem.DirectoryExists(outFilePath) Then OpenFileDialog2.InitialDirectory = outFilePath

        OpenFileDialog2.DefaultExt = ".pdf"
        OpenFileDialog2.Filter = "pdf files (*.pdf)|*.pdf|All files (*.*)|*.*"
        OpenFileDialog2.FilterIndex = 1
        'OpenFileDialog2.RestoreDirectory = True
        OpenFileDialog2.FileName = ""
        If OpenFileDialog2.ShowDialog() = Windows.Forms.DialogResult.Cancel Then Exit Sub
        files = OpenFileDialog2.FileNames
        For Each file In files
            Arg1 = Arg1 + " " + """" & file & """"
        Next
        SaveFileDialog2.DefaultExt = sExtension
        SaveFileDialog2.Filter = "PDF file (*.pdf)|*.pdf|PNG file (*.png)|*.png|JPEG file (*.jpg)|*.jpg|BITMAP file (*.bmp)|*.bmp|TIFF file (*.tif)|*.tif|All files (*.*)|*.*"
        SaveFileDialog2.FilterIndex = iIndex

        If SaveFileDialog2.ShowDialog() = Windows.Forms.DialogResult.Cancel Then Exit Sub
        outFile = """" & SaveFileDialog2.FileName & """"

        'ExeLine = My.Settings.GhostScriptPath & " -sDEVICE=pdfwrite" & " -r600 -dNOPAUSE -dSAFED -sPAPERSIZE=A4 -dBATCH -sOutputFile=" & outFile & Arg1
        ExeLine = My.Settings.GhostScriptPath & " -sDEVICE=" & sDevice & " -r600 -dNOPAUSE -dSAFED -sPAPERSIZE=A4 -dBATCH -sOutputFile=" & outFile & Arg1
        'MsgBox(ExeLine)
        My.Computer.Clipboard.SetText(ExeLine)

        Shell(ExeLine, AppWinStyle.Hide, True)
    End Sub

    Private Sub ManagePDFConvertMenu()
        If My.Settings.ArchiveFileType.ToUpper = "PDF" Then
            UnisciPDFToolStripMenuItem.Text = "Unsici PDF"
            OpenFileDialog2.Multiselect = True
        Else
            UnisciPDFToolStripMenuItem.Text = "Converti PDF"
            OpenFileDialog2.Multiselect = False
        End If
    End Sub


    Private Sub CreaCopiaDiSicurezzaToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CreaCopiaDiSicurezzaToolStripMenuItem.Click

        If MsgBox("Si vuole veramente creare una copia di sicurezza del PPManager?", MsgBoxStyle.YesNo, "Creazione copia di sicurezza") = MsgBoxResult.No Then Exit Sub
        Dim BackupDir As String = My.Settings.Backup_folder & "\Backup_" & Now.Year & Now.Month & Now.Day & Now.Hour & Now.Minute & Now.Second
        My.Computer.FileSystem.CreateDirectory(BackupDir)

        Dialog5.Show()
        Dialog5.Label1.Text = "Creazione copia di sicurezza..."
        Dialog5.Refresh()
        Dialog5.ProgressBar1.Maximum = My.Computer.FileSystem.GetFiles(Application.StartupPath, FileIO.SearchOption.SearchAllSubDirectories, "*").Count
        Dialog5.ProgressBar1.Minimum = 0

        Dim i As Long
        For Each foundFile As String In My.Computer.FileSystem.GetFiles(Application.StartupPath, FileIO.SearchOption.SearchAllSubDirectories, "*")
            Dialog5.ProgressBar1.Value = i
            i = i + 1
            Dialog5.Refresh()
            My.Computer.FileSystem.CopyFile(foundFile, Replace(foundFile, Application.StartupPath, BackupDir))
        Next
        Dialog5.Close()
    End Sub

    Private Sub ApriCartellaArchivioProtocolliToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApriCartellaArchivioProtocolliToolStripMenuItem.Click
        CompileIfDB()

        Dim outFilePath As String
        outFilePath = My.Settings.Root & "\Reports\" & IfDB.Tables(0).Rows(4).Item(1) & "\" & IfDB.Tables(0).Rows(5).Item(1) & "\" & IfDB.Tables(0).Rows(6).Item(1) & "\" & IfDB.Tables(0).Rows(7).Item(1)
        Shell("explorer " & "" & outFilePath & "", AppWinStyle.NormalFocus)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim ifCol As DataColumn 'System.Windows.Forms.DataGridViewColumn
        Dim ifRow As DataRow
        Dim NewRow As DataRow
        Dim i As Integer

        IfDB.Clear()
        IfDB = Nothing
        IfDB = New DataSet


        Dim MyTable As DataTable
        MyTable = New Data.DataTable("Inputs")
        IfDB.Tables.Add(MyTable)
        Dim C1 As New DataColumn("Item", Type.GetType("System.String"))
        Dim C2 As New DataColumn("Value", Type.GetType("System.String"))
        MyTable.Columns.Add(C1)
        MyTable.Columns.Add(C2)
        i = 0
        For Each ifCol In MyDB.Tables(0).Columns
            NewRow = IfDB.Tables(0).NewRow()
            NewRow(0) = ifCol.ColumnName
            Try
                NewRow(1) = MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(i)
                i = i + 1
            Catch ex As Exception
            End Try
            IfDB.Tables(0).Rows.Add(NewRow)
        Next


        IfDB.AcceptChanges()
        'EditMode = True
        'Dialog1.ShowDialog()
        'If Dialog1.DialogResult = Windows.Forms.DialogResult.Cancel Then Exit Sub

        Dim PathPP As String
        Dim OldName As String
        PathPP = My.Settings.Root & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(4) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(5) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(6) & "\" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(7)
        i = 0
        For Each ifRow In IfDB.Tables(0).Rows
            If i = 2 Then
                If ifRow.Item(1).Equals(System.DBNull.Value) Then ifRow.Item(1) = " "
                If My.Computer.FileSystem.FileExists(ifRow.Item(1)) Then
                    If ifRow.Item(1).ToString <> PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString) Then
                        My.Computer.FileSystem.CopyFile(ifRow.Item(1).ToString, PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString), True)
                        ifRow.Item(1) = PathPP & "\" & My.Computer.FileSystem.GetName(ifRow.Item(1).ToString)
                    End If
                End If
            End If
            MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(i) = ifRow.Item(1)
            i = i + 1
        Next
        MyDB.AcceptChanges()
        '------------
        If MsgBox("Si vuole AGGIORNARE il programma per: " & vbCrLf & vbCrLf & PathPP & vbCrLf & vbCrLf & "Rispondendo con SI il programma gi registrato verr sostituito con quello attualmente attivo in PC-DMIS!", MsgBoxStyle.YesNo, "Aggiornamento programma") = MsgBoxResult.No Then Exit Sub

        My.Computer.FileSystem.CreateDirectory(PathPP)

        If UCase(My.Settings.Software) = "QUINDOS" Then
            InterfaceFileWrite("SAVE", PathPP & "\P_" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(0) & "_" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(1))
        Else
            Dim PCDApp As PCDLRN.Application
            Dim PP As PCDLRN.PartProgram
            If PCDExists() = False Then
                MsgBox("PC-DMIS non  aperto!" & vbCrLf & vbCrLf & "Non  possibile aggiornare il programma!", MsgBoxStyle.Information)
                Exit Sub
            End If
            PCDApp = CreateObject("PCDLRN.Application")
            PP = PCDApp.ActivePartProgram
            If PP Is Nothing Then
                MsgBox("Nessun programma aperto in PC-DMIS!" & vbCrLf & vbCrLf & "Nessun aggiornamento avvenuto!")
                Exit Sub
            End If

            Me.Refresh()
            Dialog5.Show()
            Dialog5.Refresh()
            OldName = PP.FullName
            PP.SaveAs(PathPP & "\P_" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(0) & "_" & MyDB.Tables(0).Rows.Find(GridPPs.CurrentRow.Cells.Item(0).Value).Item(1))
            'PP.SaveAs(PathPP & "\P_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(0) & "_" & MyDB.Tables(0).Rows(MyDB.Tables(0).Rows.Count - 1).Item(1))
            PP.SaveAs(OldName)
        End If

        Dialog5.Close()

    End Sub
    Function RecDMS(ByVal Stringa As String) As Double
        Dim i As Integer, pos1 As Integer, pos2 As Integer, dsign As Integer
        Dim p1 As Double, p2 As Double, p3 As Double

        dsign = InStr(1, Stringa, "-")
        If dsign > 0 Then dsign = -1
        If dsign = 0 Then dsign = 1

        RecDMS = 0
        i = Len(Stringa)
        If i > 6 Then
            pos1 = InStr(1, Stringa, ".")
            pos2 = InStr(pos1 + 1, Stringa, ".")
            If pos1 <> 0 And pos2 <> 0 Then
                p1 = CDbl(Mid$(Stringa, pos2 + 1, 2))
                p2 = CDbl(Mid$(Stringa, pos1 + 1, 2))
                p1 = p1 / 60
                p2 = ((p2 + p1) / 60)
                p3 = Math.Abs(CDbl(Mid(Stringa, 1, pos1 - 1)))
                p3 = p3 + p2
                If p3 = 0 Then
                    RecDMS = 0.0000001
                Else
                    RecDMS = Format(dsign * p3, "####.############")
                End If
            End If
        End If
    End Function

End Class
